/*
 *  List<T>  -    
 */
public class List<T>
{
 //---   ---
 private Node<T> first;

 //---   ---
 public List()
 {
  this.first = null;
 }

// ---   ""     ---
 //--- -""   ---
 public boolean isEmpty()
 {
  return (this.first == null);
 }
 
 //---             ---
 //---  null  .   ,  ---
 public Node<T> getFirst()
 {
  return this.first;
 }

 //---   x        ---
 //---         /pos     ---
 //---     x ,null  pos  ---
 //---              ---
 //---           null     pos :  ---
 public Node<T> insert (Node<T> pos, T x)
 {
  Node<T> temp = new Node<T>(x);   
  if (pos == null)
  {
   temp.setNext (this.first);
   this.first = temp;
  }
  else
  { 
   temp.setNext (pos.getNext());
   pos.setNext (temp);
  }
  return temp; 
 }
 
 //--- 
 public Node<T> remove (Node<T> pos)
 {   
   if (this.first == pos)
    this.first = pos.getNext(); 
   else
   {
         Node<T> prevPos = this.getFirst();
         while (prevPos.getNext() != pos)
          prevPos = prevPos.getNext();
    prevPos.setNext (pos.getNext());
   } 
   // Node<T> nextPos = pos.getNext();
   // pos.setNext (null);
   // return nextPos;
   
   
   pos = pos.getNext();
   return pos;
 }
 
 public String toString()
 {
  String str = "[";
  
  Node<T> pos= this.first;
  while(pos != null)
  {
   str = str + pos.getInfo().toString();
   if (pos.getNext() != null)
    str = str + " , ";
   pos = pos.getNext();
  }
  str = str + "]";
  
  return str;
 }
 
}
